Introduction
The Named Cell Templates feature allows you to define reusable cell configuration templates that can be applied to cells or ranges. Each template can contain style, conditional formats, data validations, and cell states.
You can access the named cell templates manager through the workbook instance:
Add a Template
Use add(name, template) to register a new template:
Create Template from Cell
Use createFromCell(name, sheet, row, col, options) to create a template from an existing cell's configuration:
Apply Template
Use sheet.applyNamedCellTemplate(name, address) to apply a template to a range:
Or use cellRange.applyNamedCellTemplate(name):
Manage Templates
Template Structure
The template object follows the INamedCellTemplate interface:
<template>
<div class="sample-tutorial">
<div class="sample-container">
<gc-spread-sheets :hostStyle="hostStyle" @workbookInitialized="initSpread">
<gc-worksheet></gc-worksheet>
<gc-worksheet></gc-worksheet>
<gc-worksheet></gc-worksheet>
<gc-worksheet></gc-worksheet>
<gc-worksheet></gc-worksheet>
</gc-spread-sheets>
</div>
<div class="options-container">
<div class="info-tip">The left side displays preset named templates. Switch to the Playground sheet to apply templates.</div>
<div class="section-title">Apply Template</div>
<div class="option-row">
<label for="templateSelect">Template:</label>
<select id="templateSelect" v-model="selectedTemplate">
<option v-for="name in templateNames" :key="name" :value="name">{{ name }}</option>
</select>
</div>
<div class="option-row">
<label for="targetRange">Target Range:</label>
<input id="targetRange" v-model="targetRange" type="text" placeholder="e.g. A1:A10" />
</div>
<div class="option-row">
<input id="applyBtn" type="button" value="Apply Template" @click="applyTemplate" />
</div>
<div class="section-title">Create From Cell</div>
<div class="option-row">
<label for="newTemplateName">Template Name:</label>
<input id="newTemplateName" v-model="newTemplateName" type="text" placeholder="Enter template name" />
</div>
<div class="option-row">
<label>Options:</label>
<div class="checkbox-row">
<input id="optStyle" v-model="createOptions.style" type="checkbox" />
<label for="optStyle">Style</label>
</div>
<div class="checkbox-row">
<input id="optConditionalFormat" v-model="createOptions.conditionalFormat" type="checkbox" />
<label for="optConditionalFormat">Conditional Format</label>
</div>
<div class="checkbox-row">
<input id="optDataValidation" v-model="createOptions.dataValidation" type="checkbox" />
<label for="optDataValidation">Data Validation</label>
</div>
<div class="checkbox-row">
<input id="optCellState" v-model="createOptions.cellState" type="checkbox" />
<label for="optCellState">Cell State</label>
</div>
</div>
<div class="option-row">
<input id="createFromCellBtn" type="button" value="Create From Cell" @click="createTemplate" />
</div>
<div class="section-title">Template Management</div>
<div class="option-row">
<label for="templateList">Registered Templates:</label>
<select id="templateList" v-model="selectedListTemplate" size="12">
<option v-for="name in templateNames" :key="name" :value="name">{{ name }}</option>
</select>
</div>
<div class="option-row">
<input id="removeBtn" type="button" value="Remove Selected" @click="removeTemplate" />
<input id="clearBtn" type="button" value="Clear All" @click="clearTemplates" />
</div>
</div>
</div>
</template>
<script setup>
import { onBeforeUnmount, reactive, ref } from 'vue';
import {
DEFAULT_CREATE_OPTIONS,
DEFAULT_TARGET_RANGE,
applyTemplateToRange,
clearNamedTemplates,
createTemplateFromSelection,
getOrderedRegisteredTemplateNames,
initializeNamedCellTemplateDemo,
removeNamedTemplate,
syncSelectionTargetRange
} from './demo-logic.js';
const hostStyle = {
width: '100%',
height: '100%'
};
const spread = ref(null);
const selectionCleanup = ref(null);
const templateNames = ref([]);
const selectedTemplate = ref('');
const selectedListTemplate = ref('');
const targetRange = ref(DEFAULT_TARGET_RANGE);
const newTemplateName = ref('');
const createOptions = reactive({ ...DEFAULT_CREATE_OPTIONS });
function syncTemplateState(names) {
templateNames.value = names;
selectedTemplate.value = names.indexOf(selectedTemplate.value) !== -1 ? selectedTemplate.value : (names[0] || '');
selectedListTemplate.value = names.indexOf(selectedListTemplate.value) !== -1 ? selectedListTemplate.value : (names[0] || '');
}
function initSpread(workbook) {
spread.value = workbook;
initializeNamedCellTemplateDemo(workbook);
syncTemplateState(getOrderedRegisteredTemplateNames(workbook));
if (selectionCleanup.value) {
selectionCleanup.value();
}
selectionCleanup.value = syncSelectionTargetRange(workbook, function (value) {
targetRange.value = value;
});
}
function withSpread(action) {
if (!spread.value) {
return;
}
try {
action(spread.value);
} catch (error) {
window.alert(error.message);
}
}
function applyTemplate() {
withSpread(function (workbook) {
applyTemplateToRange(workbook, selectedTemplate.value, targetRange.value);
});
}
function createTemplate() {
withSpread(function (workbook) {
syncTemplateState(createTemplateFromSelection(workbook, newTemplateName.value, createOptions));
newTemplateName.value = '';
});
}
function removeTemplate() {
withSpread(function (workbook) {
syncTemplateState(removeNamedTemplate(workbook, selectedListTemplate.value));
});
}
function clearTemplates() {
withSpread(function (workbook) {
syncTemplateState(clearNamedTemplates(workbook));
});
}
onBeforeUnmount(function () {
if (selectionCleanup.value) {
selectionCleanup.value();
}
});
</script>
<style>
html,
body,
#app {
height: 100%;
margin: 0;
}
body {
position: absolute;
top: 0;
right: 0;
bottom: 0;
left: 0;
}
.sample-tutorial {
position: relative;
display: flex;
height: 100%;
overflow: hidden;
}
.sample-container {
width: calc(100% - 320px);
height: 100%;
overflow: hidden;
}
.options-container {
width: 320px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
border-left: 1px solid #e5e5e5;
}
.info-tip {
background: #e7f3ff;
border-left: 3px solid #2196f3;
border-radius: 4px;
padding: 8px 10px;
font-size: 13px;
color: #333;
line-height: 1.4;
margin-bottom: 8px;
}
.section-title {
font-weight: bold;
font-size: 13px;
border-bottom: 1px solid #ddd;
padding-bottom: 4px;
margin-top: 16px;
margin-bottom: 8px;
}
.section-title:first-child {
margin-top: 0;
}
.option-row {
font-size: 14px;
padding: 2px 0;
margin-top: 6px;
}
.option-row label {
display: block;
margin-bottom: 4px;
}
.checkbox-row {
margin: 4px 0;
}
.checkbox-row label {
display: inline;
margin-left: 4px;
}
input[type=text] {
width: 100%;
box-sizing: border-box;
padding: 4px 6px;
}
select {
width: 100%;
padding: 4px;
}
input[type=button] {
margin-top: 6px;
display: block;
width: 100%;
padding: 6px 8px;
cursor: pointer;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.2.2-master-2026-09-02-2133/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'cdn:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-slicers': 'cdn:@mescius/spread-sheets-slicers/index.js',
'@mescius/spread-sheets-charts': 'cdn:@mescius/spread-sheets-charts/index.js',
'@mescius/spread-sheets-vue': 'cdn:@mescius/spread-sheets-vue/index.js',
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

Introduction
The Named Cell Templates feature allows you to define reusable cell configuration templates that can be applied to cells or ranges. Each template can contain style, conditional formats, data validations, and cell states.
You can access the named cell templates manager through the workbook instance:
Add a Template
Use add(name, template) to register a new template:
Create Template from Cell
Use createFromCell(name, sheet, row, col, options) to create a template from an existing cell's configuration:
Apply Template
Use sheet.applyNamedCellTemplate(name, address) to apply a template to a range:
Or use cellRange.applyNamedCellTemplate(name):
Manage Templates
Template Structure
The template object follows the INamedCellTemplate interface:
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
import { App } from './app-func';
createRoot(document.getElementById('app')).render(<App />);
import * as React from 'react';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import {
DEFAULT_CREATE_OPTIONS,
DEFAULT_TARGET_RANGE,
applyTemplateToRange,
clearNamedTemplates,
createTemplateFromSelection,
getOrderedRegisteredTemplateNames,
initializeNamedCellTemplateDemo,
removeNamedTemplate,
syncSelectionTargetRange
} from './demo-logic';
export function App() {
var spreadRef = React.useRef(null);
var cleanupRef = React.useRef(null);
var templateState = React.useState([]);
var templateNames = templateState[0];
var setTemplateNames = templateState[1];
var selectedTemplateState = React.useState('');
var selectedTemplate = selectedTemplateState[0];
var setSelectedTemplate = selectedTemplateState[1];
var selectedListState = React.useState('');
var selectedListTemplate = selectedListState[0];
var setSelectedListTemplate = selectedListState[1];
var targetRangeState = React.useState(DEFAULT_TARGET_RANGE);
var targetRange = targetRangeState[0];
var setTargetRange = targetRangeState[1];
var newTemplateNameState = React.useState('');
var newTemplateName = newTemplateNameState[0];
var setNewTemplateName = newTemplateNameState[1];
var createOptionsState = React.useState(DEFAULT_CREATE_OPTIONS);
var createOptions = createOptionsState[0];
var setCreateOptions = createOptionsState[1];
function syncTemplateState(names) {
setTemplateNames(names);
setSelectedTemplate(function (previous) {
if (previous && names.indexOf(previous) !== -1) {
return previous;
}
return names[0] || '';
});
setSelectedListTemplate(function (previous) {
if (previous && names.indexOf(previous) !== -1) {
return previous;
}
return names[0] || '';
});
}
function initSpread(spread) {
spreadRef.current = spread;
initializeNamedCellTemplateDemo(spread);
syncTemplateState(getOrderedRegisteredTemplateNames(spread));
if (cleanupRef.current) {
cleanupRef.current();
}
cleanupRef.current = syncSelectionTargetRange(spread, setTargetRange);
}
function withSpread(action) {
if (!spreadRef.current) {
return;
}
try {
action(spreadRef.current);
} catch (error) {
window.alert(error.message);
}
}
function handleApplyTemplate() {
withSpread(function (spread) {
applyTemplateToRange(spread, selectedTemplate, targetRange);
});
}
function handleCreateTemplate() {
withSpread(function (spread) {
syncTemplateState(createTemplateFromSelection(spread, newTemplateName, createOptions));
setNewTemplateName('');
});
}
function handleRemoveTemplate() {
withSpread(function (spread) {
syncTemplateState(removeNamedTemplate(spread, selectedListTemplate));
});
}
function handleClearTemplates() {
withSpread(function (spread) {
syncTemplateState(clearNamedTemplates(spread));
});
}
function updateCreateOption(name, checked) {
setCreateOptions(function (previous) {
return Object.assign({}, previous, { [name]: checked });
});
}
return (
<div className="sample-tutorial">
<div className="sample-container">
<SpreadSheets hostStyle={{ width: '100%', height: '100%' }} workbookInitialized={initSpread}>
<Worksheet />
<Worksheet />
<Worksheet />
<Worksheet />
<Worksheet />
</SpreadSheets>
</div>
<div className="options-container">
<div className="info-tip">The left side displays preset named templates. Switch to the Playground sheet to apply templates.</div>
<div className="section-title">Apply Template</div>
<div className="option-row">
<label htmlFor="templateSelect">Template:</label>
<select id="templateSelect" value={selectedTemplate} onChange={function (event) { setSelectedTemplate(event.target.value); }}>
{templateNames.map(function (name) {
return <option key={name} value={name}>{name}</option>;
})}
</select>
</div>
<div className="option-row">
<label htmlFor="targetRange">Target Range:</label>
<input id="targetRange" type="text" value={targetRange} placeholder="e.g. A1:A10" onChange={function (event) { setTargetRange(event.target.value); }} />
</div>
<div className="option-row">
<input type="button" id="applyBtn" value="Apply Template" onClick={handleApplyTemplate} />
</div>
<div className="section-title">Create From Cell</div>
<div className="option-row">
<label htmlFor="newTemplateName">Template Name:</label>
<input id="newTemplateName" type="text" value={newTemplateName} placeholder="Enter template name" onChange={function (event) { setNewTemplateName(event.target.value); }} />
</div>
<div className="option-row">
<label>Options:</label>
<div className="checkbox-row">
<input id="optStyle" type="checkbox" checked={createOptions.style} onChange={function (event) { updateCreateOption('style', event.target.checked); }} />
<label htmlFor="optStyle">Style</label>
</div>
<div className="checkbox-row">
<input id="optConditionalFormat" type="checkbox" checked={createOptions.conditionalFormat} onChange={function (event) { updateCreateOption('conditionalFormat', event.target.checked); }} />
<label htmlFor="optConditionalFormat">Conditional Format</label>
</div>
<div className="checkbox-row">
<input id="optDataValidation" type="checkbox" checked={createOptions.dataValidation} onChange={function (event) { updateCreateOption('dataValidation', event.target.checked); }} />
<label htmlFor="optDataValidation">Data Validation</label>
</div>
<div className="checkbox-row">
<input id="optCellState" type="checkbox" checked={createOptions.cellState} onChange={function (event) { updateCreateOption('cellState', event.target.checked); }} />
<label htmlFor="optCellState">Cell State</label>
</div>
</div>
<div className="option-row">
<input type="button" id="createFromCellBtn" value="Create From Cell" onClick={handleCreateTemplate} />
</div>
<div className="section-title">Template Management</div>
<div className="option-row">
<label htmlFor="templateList">Registered Templates:</label>
<select id="templateList" size="12" value={selectedListTemplate} onChange={function (event) { setSelectedListTemplate(event.target.value); }}>
{templateNames.map(function (name) {
return <option key={name} value={name}>{name}</option>;
})}
</select>
</div>
<div className="option-row">
<input type="button" id="removeBtn" value="Remove Selected" onClick={handleRemoveTemplate} />
<input type="button" id="clearBtn" value="Clear All" onClick={handleClearTemplates} />
</div>
</div>
</div>
);
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
html,
body,
#app {
height: 100%;
margin: 0;
}
body {
position: absolute;
top: 0;
right: 0;
bottom: 0;
left: 0;
}
.sample-tutorial {
position: relative;
display: flex;
height: 100%;
overflow: hidden;
}
.sample-container {
width: calc(100% - 320px);
height: 100%;
overflow: hidden;
}
.options-container {
width: 320px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
border-left: 1px solid #e5e5e5;
}
.info-tip {
background: #e7f3ff;
border-left: 3px solid #2196f3;
border-radius: 4px;
padding: 8px 10px;
font-size: 13px;
color: #333;
line-height: 1.4;
margin-bottom: 8px;
}
.section-title {
font-weight: bold;
font-size: 13px;
border-bottom: 1px solid #ddd;
padding-bottom: 4px;
margin-top: 16px;
margin-bottom: 8px;
}
.section-title:first-child {
margin-top: 0;
}
.option-row {
font-size: 14px;
padding: 2px 0;
margin-top: 6px;
}
.option-row label {
display: block;
margin-bottom: 4px;
}
.checkbox-row {
margin: 4px 0;
}
.checkbox-row label {
display: inline;
margin-left: 4px;
}
input[type=text] {
width: 100%;
box-sizing: border-box;
padding: 4px 6px;
}
select {
width: 100%;
padding: 4px;
}
input[type=button] {
margin-top: 6px;
display: block;
width: 100%;
padding: 6px 8px;
cursor: pointer;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.2.2-master-2026-09-02-2133/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'cdn:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-slicers': 'cdn:@mescius/spread-sheets-slicers/index.js',
'@mescius/spread-sheets-charts': 'cdn:@mescius/spread-sheets-charts/index.js',
'@mescius/spread-sheets-react': 'cdn:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

Introduction
The Named Cell Templates feature allows you to define reusable cell configuration templates that can be applied to cells or ranges. Each template can contain style, conditional formats, data validations, and cell states.
You can access the named cell templates manager through the workbook instance:
Add a Template
Use add(name, template) to register a new template:
Create Template from Cell
Use createFromCell(name, sheet, row, col, options) to create a template from an existing cell's configuration:
Apply Template
Use sheet.applyNamedCellTemplate(name, address) to apply a template to a range:
Or use cellRange.applyNamedCellTemplate(name):
Manage Templates
Template Structure
The template object follows the INamedCellTemplate interface:
import { Component, NgModule, NgZone, enableProdMode } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import {
DEFAULT_CREATE_OPTIONS,
DEFAULT_TARGET_RANGE,
applyTemplateToRange,
clearNamedTemplates,
createTemplateFromSelection,
getOrderedRegisteredTemplateNames,
initializeNamedCellTemplateDemo,
removeNamedTemplate
} from './demo-logic';
import './styles.css';
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
constructor() { }
spread: any = null;
selectionCleanup: any = null;
hostStyle = {
width: '100%',
height: '100%'
};
templateNames: string[] = [];
selectedTemplate = '';
selectedListTemplate = '';
targetRange = DEFAULT_TARGET_RANGE;
newTemplateName = '';
createOptions = Object.assign({}, DEFAULT_CREATE_OPTIONS);
initSpread(event: any) {
this.spread = event && event.spread ? event.spread : event;
initializeNamedCellTemplateDemo(this.spread);
this.refreshTemplateState(getOrderedRegisteredTemplateNames(this.spread));
this.targetRange = DEFAULT_TARGET_RANGE;
this.spread.bind(GC.Spread.Sheets.Events.SelectionChanged, (_sender: any, info: any) => {
if (info.newSelections && info.newSelections.length > 0) {
this.targetRange = GC.Spread.Sheets.CalcEngine.rangeToFormula(info.newSelections[0]);
}
});
}
refreshTemplateState(names: string[]) {
this.templateNames = names;
this.selectedTemplate = names.indexOf(this.selectedTemplate) !== -1 ? this.selectedTemplate : (names[0] || '');
this.selectedListTemplate = names.indexOf(this.selectedListTemplate) !== -1 ? this.selectedListTemplate : (names[0] || '');
}
withSpread(action: (spread: any) => void) {
if (!this.spread) {
return;
}
try {
action(this.spread);
} catch (error: any) {
window.alert(error.message);
}
}
applyTemplate() {
this.withSpread((spread: any) => {
applyTemplateToRange(spread, this.selectedTemplate, this.targetRange);
});
}
createTemplate() {
this.withSpread((spread: any) => {
this.refreshTemplateState(createTemplateFromSelection(spread, this.newTemplateName, this.createOptions));
this.newTemplateName = '';
});
}
removeTemplate() {
this.withSpread((spread: any) => {
this.refreshTemplateState(removeNamedTemplate(spread, this.selectedListTemplate));
});
}
clearTemplates() {
this.withSpread((spread: any) => {
this.refreshTemplateState(clearNamedTemplates(spread));
});
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule, FormsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
enableProdMode();
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<div class="sample-container">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
<gc-worksheet></gc-worksheet>
<gc-worksheet></gc-worksheet>
<gc-worksheet></gc-worksheet>
<gc-worksheet></gc-worksheet>
<gc-worksheet></gc-worksheet>
</gc-spread-sheets>
</div>
<div class="options-container">
<div class="info-tip">The left side displays preset named templates. Switch to the Playground sheet to apply templates.</div>
<div class="section-title">Apply Template</div>
<div class="option-row">
<label for="templateSelect">Template:</label>
<select id="templateSelect" [(ngModel)]="selectedTemplate">
<option *ngFor="let name of templateNames" [value]="name">{{ name }}</option>
</select>
</div>
<div class="option-row">
<label for="targetRange">Target Range:</label>
<input id="targetRange" type="text" [(ngModel)]="targetRange" placeholder="e.g. A1:A10" />
</div>
<div class="option-row">
<input type="button" id="applyBtn" value="Apply Template" (click)="applyTemplate()" />
</div>
<div class="section-title">Create From Cell</div>
<div class="option-row">
<label for="newTemplateName">Template Name:</label>
<input id="newTemplateName" type="text" [(ngModel)]="newTemplateName" placeholder="Enter template name" />
</div>
<div class="option-row">
<label>Options:</label>
<div class="checkbox-row">
<input id="optStyle" type="checkbox" [(ngModel)]="createOptions.style" />
<label for="optStyle">Style</label>
</div>
<div class="checkbox-row">
<input id="optConditionalFormat" type="checkbox" [(ngModel)]="createOptions.conditionalFormat" />
<label for="optConditionalFormat">Conditional Format</label>
</div>
<div class="checkbox-row">
<input id="optDataValidation" type="checkbox" [(ngModel)]="createOptions.dataValidation" />
<label for="optDataValidation">Data Validation</label>
</div>
<div class="checkbox-row">
<input id="optCellState" type="checkbox" [(ngModel)]="createOptions.cellState" />
<label for="optCellState">Cell State</label>
</div>
</div>
<div class="option-row">
<input type="button" id="createFromCellBtn" value="Create From Cell" (click)="createTemplate()" />
</div>
<div class="section-title">Template Management</div>
<div class="option-row">
<label for="templateList">Registered Templates:</label>
<select id="templateList" size="12" [(ngModel)]="selectedListTemplate">
<option *ngFor="let name of templateNames" [value]="name">{{ name }}</option>
</select>
</div>
<div class="option-row">
<input type="button" id="removeBtn" value="Remove Selected" (click)="removeTemplate()" />
<input type="button" id="clearBtn" value="Clear All" (click)="clearTemplates()" />
</div>
</div>
</div>
html,
body {
height: 100%;
margin: 0;
}
body {
position: absolute;
top: 0;
right: 0;
bottom: 0;
left: 0;
}
.sample-tutorial {
position: relative;
display: flex;
height: 100%;
overflow: hidden;
}
.sample-container {
width: calc(100% - 320px);
height: 100%;
overflow: hidden;
}
.options-container {
width: 320px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
border-left: 1px solid #e5e5e5;
}
.info-tip {
background: #e7f3ff;
border-left: 3px solid #2196f3;
border-radius: 4px;
padding: 8px 10px;
font-size: 13px;
color: #333;
line-height: 1.4;
margin-bottom: 8px;
}
.section-title {
font-weight: bold;
font-size: 13px;
border-bottom: 1px solid #ddd;
padding-bottom: 4px;
margin-top: 16px;
margin-bottom: 8px;
}
.section-title:first-child {
margin-top: 0;
}
.option-row {
font-size: 14px;
padding: 2px 0;
margin-top: 6px;
}
.option-row label {
display: block;
margin-bottom: 4px;
}
.checkbox-row {
margin: 4px 0;
}
.checkbox-row label {
display: inline;
margin-left: 4px;
}
input[type=text] {
width: 100%;
box-sizing: border-box;
padding: 4px 6px;
}
select {
width: 100%;
padding: 4px;
}
input[type=button] {
margin-top: 6px;
display: block;
width: 100%;
padding: 6px 8px;
cursor: pointer;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.2.2-master-2026-09-02-2133/'
},
// map tells the System loader where to look for things
map: {
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'cdn:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-slicers': 'cdn:@mescius/spread-sheets-slicers/index.js',
'@mescius/spread-sheets-charts': 'cdn:@mescius/spread-sheets-charts/index.js',
'@mescius/spread-sheets-angular': 'cdn:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);